#ifndef _ZKIRPALMSERVICE_H_
#define _ZKIRPALMSERVICE_H_

#if defined(_WIN32) || defined(__WIN32__)
#if defined(palm_EXPORTS)
#define  ZKINTERFACE
#else
#define  ZKINTERFACE 
#endif
#elif defined(linux) || defined(__linux)
#if __GNUC__ >= 4
#define ZKINTERFACE __attribute__ ((visibility ("default")))
#else
#define ZKINTERFACE
#endif
#endif


#ifndef APICALL
#ifdef _WIN32
#define APICALL __stdcall
#else
#define APICALL
#endif
#endif

#if 0
#ifdef __cplusplus
extern "C"
{
#endif
ZKINTERFACE int APICALL ZKPalmServiceVersion(int *versionData, int *major, int *minor,char *version, int len);
ZKINTERFACE int APICALL ZKPalmServiceInit(void** handle, int width, int height,bool IsMallocDb);
ZKINTERFACE int APICALL ZKPalmServiceFinal();
ZKINTERFACE int APICALL ZKPalmServiceSetParam(void *handle,int paramIndex, int paramValue);
ZKINTERFACE int APICALL ZKPalmServiceExtractTemplate(void *handle, unsigned char *imgBuffer, int extractType, unsigned char *rawTemplate,int *cbRawTemplate, unsigned char *verTemplate,  int *cbVerTemplate, int *quality,int *pZKPalmRect);
ZKINTERFACE int APICALL ZKPalmServiceVerify(void * handle,const unsigned char *regTemplate, unsigned char *verTemplate);
ZKINTERFACE int APICALL ZKPalmServiceVerifyByID(void *handle, const unsigned char *verTemplate, const char *id);
ZKINTERFACE int APICALL ZKPalmServiceMergeTemplates(void *handle,unsigned char **rawTemplates,int mergedCount,unsigned char* pMergeTemplate,int *cbMergeTemplate);
ZKINTERFACE int APICALL ZKPalmServiceDBAdd(void *handle, const char *id, unsigned char *regTemplate,int count);
ZKINTERFACE int APICALL  ZKPalmServiceDBDel(void *handle, const char *id);
ZKINTERFACE int APICALL ZKPalmServiceDBCount(void * handle);
ZKINTERFACE int APICALL ZKPalmServiceDBClear(void *handle);
ZKINTERFACE int APICALL ZKPalmServiceDBIdentify(void *handle, const unsigned char *verTemplate, char *id, int minScore, int maxScore);
//add 20201109 新增通过登记模板进行1:N比对
ZKINTERFACE int APICALL ZKPalmServiceEnrollDBIdentify( void *handle, const unsigned char *enrollTemplate, char *id, int minScore, int maxScore );
#ifdef __cplusplus
};
#endif
#else
typedef int (* P_ZKPalmServiceVersion)(int *versionData, int *major, int *minor,char *version, int len);
typedef int (* P_ZKPalmServiceInit)(void** handle, int width, int height,bool IsMallocDb);
typedef int (* P_ZKPalmServiceFinal)();
typedef int (* P_ZKPalmServiceSetParam)(void *handle,int paramIndex, int paramValue);
typedef int (* P_ZKPalmServiceExtractTemplate)(void *handle, unsigned char *imgBuffer, int extractType, unsigned char *rawTemplate,int *cbRawTemplate, unsigned char *verTemplate,  int *cbVerTemplate, int *quality,int *pZKPalmRect);
typedef int (* P_ZKPalmServiceVerify)(void * handle,const unsigned char *regTemplate, unsigned char *verTemplate);
typedef int (* P_ZKPalmServiceVerifyByID)(void *handle, const unsigned char *verTemplate, const char *id);
typedef int (* P_ZKPalmServiceMergeTemplates)(void *handle,unsigned char **rawTemplates,int mergedCount,unsigned char* pMergeTemplate,int *cbMergeTemplate);
typedef int (* P_ZKPalmServiceDBAdd)(void *handle, const char *id, unsigned char *regTemplate,int count);
typedef int (* P_ZKPalmServiceDBDel)(void *handle, const char *id);
typedef int (* P_ZKPalmServiceDBCount)(void * handle);
typedef int (* P_ZKPalmServiceDBClear)(void *handle);
typedef int (* P_ZKPalmServiceDBIdentify)(void *handle, const unsigned char *verTemplate, char *id, int minScore, int maxScore);
typedef int (* P_ZKPalmServiceEnrollDBIdentify)( void *handle, const unsigned char *enrollTemplate, char *id, int minScore, int maxScore );
#endif

#endif
