#include "operate.h"
#include "ZKBiometric/zkbiometric.h"
#include "ZKSensor/zksensor.h"
#include "../zkglobaldef.h"

Operate::Operate(QObject *parent) : QObject(parent)
{

}

void Operate::setObjects(ZKBiometric *pZKBiometric,ZKSensor *pZKSensor)
{
    this->pZKBiometric = pZKBiometric;
    this->pZKSensor = pZKSensor;
}

void Operate::slotButtonOpen()
{
    LOGDEBUG;
    pZKSensor->open();
    LOGDEBUG;
    pZKBiometric->init();
    LOGDEBUG;
}
void Operate::slotButtonClose()
{
    LOGDEBUG;
    pZKBiometric->free();
    pZKSensor->close();
    LOGDEBUG;
}
void Operate::slotButtonEnroll()
{
    pZKBiometric->add();
}
void Operate::slotButtonDelete()
{
    pZKBiometric->del();
}
void Operate::slotButtonClear()
{
    pZKBiometric->clear();
}
void Operate::slotButtonVerify()
{
    pZKBiometric->verify();
}
void Operate::slotButtonIdentify()
{
    pZKBiometric->identify();
}
void Operate::slotButtonGetParam()
{
    pZKSensor->getParam();
}
void Operate::slotRecvExtractSuccess()
{
    pZKSensor->setParam(2010,0x03);
}
