#ifndef PICTURELABEL_H
#define PICTURELABEL_H
#include <QPainter>
#include <QLabel>
#include <QPen>
#include <QColor>
#include <QDebug>
#include <QPoint>

typedef struct TT{
    int left;
    int  top;
    int right;
    int bottom;
}pTT;

class PictureLabel : public QLabel
{
    Q_OBJECT
public:
    PictureLabel(QWidget *parent);
    void setRectValue(int x,int y,int width,int height)
    {
        this->X = x;
        this->Y = y;
        this->Width = width;
        this->Height = height;

    }
    void getRectValue(int*x,int* y,int* width,int* height)
    {
        *x = this->X;
        *y = this->Y;
        *width = this->Width;
        *height = this->Height;
    }

    void setPalmRect(int *palmRect)
    {
        memcpy(this->palmRect,palmRect,sizeof(this->palmRect));

    }
    void getPalmRect(int *palmRect)
    {
        memcpy(palmRect,this->palmRect,sizeof(this->palmRect));
    }

private:
    int X;
    int Y;
    int Width;
    int Height;
    int palmRect[8];
    //重写绘制事件
    virtual void paintEvent(QPaintEvent *event) ;
private:

};
#endif // PICTURELABEL_H
