#ifndef ZKPALMERRNO_H
#define ZKPALMERRNO_H

#define ZKPALM_ERR_OK							0	/**<	操作成功 */
#define ZKPALM_ERR_FAIL							-1	/**<	操作失败 */
#define ZKPALM_ERR_NO_DEVICE					-2	/**<	设备未连接 */
#define ZKPALM_ERR_NULL_POINT					-3	/**<	空指针 */
#define ZKPALM_ERR_INVALID_PARAM				-4	/**<	无效参数 */
#define ZKPALM_ERR_NO_SUPPORT					-5	/**<	不支持 */
#define ZKPALM_ERR_INITLIB						-6	/**<	初始化算法库失败 */
#define ZKPALM_ERR_INVALID_HANDLE				-7	/**<	无效句柄 */
#define ZKPALM_ERR_NOT_DETECTED					-8	/**<	未检测到手掌 */
#define ZKPALM_ERR_MEMORY_NOT_ENOUGH			-9	/**<	软件内存分配 */
#define ZKPALM_ERR_OUT_AREA						-10	/**<	手掌不在指定区域 */
#define ZKPALM_ERR_LOADACAMLIB_FAIL				-11	/**<	加载ACAM动态库失败 */
#define ZKPALM_ERR_SETLICDATAFAIL				-12/**<设置许可文件失败*/
#define ZKPALM_ERR_EXTRACT_FAIL					-13	/**<	提前模板失败*/
#define ZKPALM_ERR_LOADBIODLL_FAIL				-14	/**<	加载手掌算法库动态库失败 */
#define ZKPALM_ERR_TEMPLATE				-15 /**<	模板格式有误 */
#define ZKPALM_ERR_DBSETFAIL				-16 /**<	添加登记模板到高速缓冲区失败 */
#define ZKPALM_ERR_ENROLLFAIL			-17 /**<	模板转换失败 */
#define ZKPALM_ERR_BADENROLLTMP			-18 /**<	要合成的模板数据有误(不全部为预登记模板数据) */
#define ZKPALM_ERR_OPENFAIL			-19 /**<打开设备失败 */

#endif
