#ifndef ZKGLOBALDEF_H
#define ZKGLOBALDEF_H


#define MAX_IMG_SIZE                                1024*1024
#define MAX_ADD_TEMPLATE_SIZE             99120
#define MAX_VER_TEMPLATE_SIZE              27120
#define MAX_MERGE_TEMPLATE_COUNT   3
#define SUCCESS_SCORE                              576
#define SIZE_64                                             64

/*
* * log debug
*/
#include <QDebug>
#include <QThread>
#define THREADID (long long)QThread::currentThreadId()
#define LOGDEBUG qDebug()<<qPrintable(QString("[%1][%2][%3]: ").arg(THREADID).arg(__func__).arg(__LINE__))



/*
* * sleep
*/
#include <stdio.h>
#include<stdlib.h>
#ifdef __linux
#include <unistd.h>
#endif
inline void zkusleep(int usec)
{
#ifdef __linux
    usleep(usec);
#endif
#ifdef __WIN32
    Sleep(usec);
#endif
}
#endif // ZKGLOBALDEF_H
